use gtk4::prelude::{ApplicationExt, ApplicationExtManual, GtkWindowExt};
// We're using gtk-builder feature here
use gtk_blueprint::get_blp;
use libadwaita::prelude::PreferencesGroupExt;

gtk_blueprint::gen_blp_map!("gui");
fn main() {
    gtk4::init().expect("GTK initialization failed");
    libadwaita::init().expect("Adwaita initialization failed");

    // Create app
    let application = gtk4::Application::builder()
        .application_id("de.teilgedanken.sieverman")
        .build();
    // Init app window and show it
    application.connect_activate(|app| {
        // You also can parse blueprint with Parser::parse
        // and then use it in gtk4::Builder
        let builder = gtk4::Builder::new();
        builder
            .add_from_string(get_blp!("gui/main_window.blp"))
            .expect("Failed to parse blueprint");

        let window = builder
            .object::<libadwaita::ApplicationWindow>("window")
            .unwrap();

        let settings: libadwaita::PreferencesGroup = builder
            .object("server_settings")
            .expect("get server settings");
        for _ in 0..5 {
            let builder = gtk4::Builder::new();
            builder
                .add_from_string(get_blp!("gui/headerbar.blp"))
                .expect("Failed to parse blueprint");
            let widget: libadwaita::PreferencesRow = builder
                .object("server_info_row")
                .expect("Couldn't get widget");
            settings.add(&widget);
        }

        window.set_application(Some(app));
        window.present();
    });

    // Run app
    application.run();
}
